#!/usr/bin/env python
# coding: utf8
# -*- coding: utf-8 -*-

import argparse
from musique.basicsynth import BasicSequenceur
from musique.exercice import GenerateurExercice
from musique.gamme import GammeTemperee

parser = argparse.ArgumentParser(description='Génère des documents à partir de la partition du thème au clair de la lune.')
parser.add_argument('--exercice-spectrogramme', help="Génère un exercice plutôt que le fichier son", dest='exerciceSpectrogramme', action='store_true',default=False)
parser.add_argument('--exercice-spectrogramme-transparent', help="Génère un exercice à projeter", dest='transparent', action='store_true',default=False)
parser.add_argument('--boomwhackers', help="Génère un exercice plutôt que le fichier son", dest='boomwhackers', nargs=1)

args = parser.parse_args()

gamme = GammeTemperee(80)


boomwhackers = ""
if not args.boomwhackers is None:
  boomwhackers = args.boomwhackers[0]


lune = [ [ [gamme.do(4), gamme.croche],
           [gamme.do(4), gamme.croche],
           [gamme.do(4), gamme.croche],
           [gamme.re(4), gamme.croche],
           
           [gamme.mi(4), gamme.noire],
           [gamme.re(4), gamme.noire],
           
           [gamme.do(4), gamme.croche],
           [gamme.mi(4), gamme.croche],
           [gamme.re(4), gamme.croche],
           [gamme.re(4), gamme.croche],
           
           [gamme.do(4), gamme.blanche],
           
           
           
        ] ]


if args.exerciceSpectrogramme or args.transparent:
  g = GenerateurExercice(gamme.bpm)
  g.setBoomwhackers(boomwhackers)
  g.setLongueurPartitionColoree(4)
  if args.exerciceSpectrogramme:
    g.genererExerciceSpectrogramme(lune, "exercices/ex-spec-lune.tex", "thème 2", "Au clair de la lune")
  if args.transparent:
    g.genererTransparentSpectrogramme(lune, "exercices/ex-proj-lune.tex", "thème 2", "Au clair de la lune")
    
else:
  print "Génération du son"
  s = BasicSequenceur(1, gamme.bpm, 0)
  s.genererMelodie(lune, "sons/lune.wav")

